'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helpers = require('./helpers.js');

const flatten = (node) => {
  const res = [];
  helpers.walk(node, (x) => {
    res.push(x);
    if (x.nodeName === 'TEMPLATE') {
      res.push(...flatten(x.content));
    }
  });
  return res;
};

const cloneNode = (node) => {
  let newNode = node.cloneNode(true);

  let fa = flatten(node);
  let fb = flatten(newNode);

  let i = fa.length;
  while (i--) {
    fb[i].$meta = helpers.copy(fa[i].$meta);
    fb[i].$meta.rootNode = fa[i].$meta.rootNode;
  }

  return newNode;
};

exports.cloneNode = cloneNode;
