'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helpers = require('./helpers.js');
var bind = require('./bind.js');
var subscribe = require('./subscribe.js');
var update = require('./update.js');
var proxy = require('./proxy.js');

const render = (mountNode, viewmodel, template, extras = {}) => {
  let vm, mounted;

  let update$1 = update.updater(mountNode, viewmodel, (prev) => mounted && viewmodel.updatedCallback(prev));

  if (!mountNode.$initData) {
    template = helpers.templateNode(template).cloneNode(true).content;

    mountNode.$subscribe = bind.bind(template, mountNode);

    update$1(template);

    extras.beforeMountCallback?.(template);

    for (let child of mountNode.children) {
      child.remove();
    }

    mountNode.appendChild(template);
  }

  vm = proxy.wrapProxy(
    viewmodel,
    helpers.debounce(() => update$1(mountNode))
  );

  subscribe.subscribe(mountNode, mountNode.$subscribe, vm);

  mounted = true;

  return vm;
};

/* 

node {
  $initData,
  $subscribe,
  $meta: {
    rootNode,
    index,
    bindings,
    listId?,
    blockData?,
    blockIndex?
  }
}

*/

exports.render = render;
